package biz.hammurapi.config;

/**
 * Context which entries can be modified.
 * @author Pavel
 *
 */
public interface MutableContext extends Context {
	
	/**
	 * Sets context value.
	 * @param name
	 * @param value
	 */
	void set(String name, Object value);
	
	/**
	 * Removes context value.
	 * @param name
	 * @return true if operation was successful. In some cases
	 * removal of name/value pair may not be supported (e.g. chained contexts).
	 */
	boolean remove(String name);
}
