package biz.hammurapi.properties;

import java.util.Set;

/**
 * Delegates all calls to the master property set.
 * Developers can override some methods, e.g. convert properties
 * from one type to another. 
 * @author Pavel
 *
 */
public class PropertySetFilter implements PropertySet {
	
	protected PropertySet master;
	
	public PropertySetFilter(PropertySet master) {
		this.master = master;
	}

	public void clear() {
		master.clear();
	}

	public boolean compareProperties(PropertySet otherSet) {
		return master.compareProperties(otherSet);
	}

	public boolean containsAll(PropertySet subSet) {
		return master.containsAll(subSet);
	}

	public Object get(String name) {
		return master.get(name);
	}

	public Set getPropertyNames() {
		return master.getPropertyNames();
	}

	public PropertySet getSubset(String prefix) {
		return master.getSubset(prefix);
	}

	public void mount(String prefix, PropertySet source) {
		master.mount(prefix, source);
	}

	public boolean remove(String name) {
		return master.remove(name);
	}

	public void set(String name, Object value) {
		master.set(name, value);
	}

	public void setAll(PropertySet source) {
		master.setAll(source);
	}

	public Object get(String name, Object defaultValue) {
		return master.get(name, defaultValue);
	}
	
	
}
