package biz.hammurapi.registry;

/**
 * Configuration components may implement this interface for
 * integration with registry browser. 
 * @author Pavel
 *
 */
public interface PropertyPage {

	/**
	 * Configuration wizard calls this method when "Next" or "Finish"
	 * buttons are clicked. If the method returns false, the wizard
	 * remains on the page. It is responsibility of the property page
	 * to communicate to the user the nature of the problem.
	 * @return False if information on the property page is not correct.
	 */
	boolean validate();
	
	/**
	 * Passes registry to the page to enable property pages to 
	 * browse the registry.
	 * @param browser
	 */
	void setBrowser(Registry registry);
}
