package biz.hammurapi.registry;

import java.util.Collection;

/**
 * Registry of Java components/services.
 * @author Pavel
 */
public interface Registry {

	/**
	 * Opens a browser to select a single component of 
	 * given target class
	 * @param targetClasses returned object shall be an instance of one
	 * of target classes.
	 * @return
	 */
	Object select(Class<?> ... targetClasses);
	
	/**
	 * Opens a browser to select multiple components of 
	 * given target class.
	 * @param targetClasses returned object shall be an instance of one
	 * of target classes.
	 * @return
	 */
	Collection<?> multiSelect(Class<?> ... targetClasses);
}
