package biz.hammurapi.sql.syntax;

import java.sql.PreparedStatement;
import java.sql.SQLException;

public class IsNull implements StatementFragment {
	
	private String columnName;

	public IsNull(String columnName) {
		this.columnName = columnName;
	}

	public String toSqlString() {
		return columnName+" IS NULL";
	}

	public int parameterize(PreparedStatement ps, int idx) throws SQLException {
		return idx;
	}

	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((columnName == null) ? 0 : columnName.hashCode());
		return result;
	}

	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final IsNull other = (IsNull) obj;
		if (columnName == null) {
			if (other.columnName != null)
				return false;
		} else if (!columnName.equals(other.columnName))
			return false;
		return true;
	}

}
