package biz.hammurapi.sql.syntax;

import java.io.Serializable;
import java.sql.PreparedStatement;
import java.sql.SQLException;

import biz.hammurapi.sql.Variant;

/**
 * Less or equal
 * @author Pavel
 *
 */
public class LessOrEqual implements StatementFragment, Serializable {
	
	private Variant variant;
	private String columnName;
	
	public LessOrEqual(String columnName, boolean value) {
		variant = new Variant(value);
		this.columnName = columnName;
	}

	public LessOrEqual(String columnName, byte value) {
		variant = new Variant(value);
		this.columnName = columnName;
	}

	public LessOrEqual(String columnName, char value) {
		variant = new Variant(value);
		this.columnName = columnName;
	}

	public LessOrEqual(String columnName, double value) {
		variant = new Variant(value);
		this.columnName = columnName;
	}

	public LessOrEqual(String columnName, float value) {
		variant = new Variant(value);
		this.columnName = columnName;
	}

	public LessOrEqual(String columnName, int value) {
		variant = new Variant(value);
		this.columnName = columnName;
	}

	public LessOrEqual(String columnName, long value) {
		variant = new Variant(value);
		this.columnName = columnName;
	}

	public LessOrEqual(String columnName, String value) {
		variant = new Variant(value);
		this.columnName = columnName;
	}

	public LessOrEqual(String columnName, Object value) {
		variant = new Variant(value);
		this.columnName = columnName;
	}

	public LessOrEqual(String columnName, Object value, int sqlType) {
		variant = new Variant(value, sqlType);
		this.columnName = columnName;
	}

	public LessOrEqual(String columnName, short value) {
		variant = new Variant(value);
		this.columnName = columnName;
	}

	public String toSqlString() {		
		return columnName + "<=?";
	}

	public int parameterize(PreparedStatement ps, int idx) throws SQLException {
		return variant.parameterize(ps, idx);
	}

	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((columnName == null) ? 0 : columnName.hashCode());
		result = prime * result + ((variant == null) ? 0 : variant.hashCode());
		return result;
	}

	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final LessOrEqual other = (LessOrEqual) obj;
		if (columnName == null) {
			if (other.columnName != null)
				return false;
		} else if (!columnName.equals(other.columnName))
			return false;
		if (variant == null) {
			if (other.variant != null)
				return false;
		} else if (!variant.equals(other.variant))
			return false;
		return true;
	}

}
