package biz.hammurapi.sql.syntax;

import java.io.Serializable;
import java.sql.PreparedStatement;
import java.sql.SQLException;

public class Not implements StatementFragment, Serializable {
	
	private StatementFragment fragment;

	public Not(StatementFragment fragment) {
		this.fragment = fragment;
	}

	public int parameterize(PreparedStatement statement, int idx) throws SQLException {
		return fragment.parameterize(statement, idx);
	}

	public String toSqlString() {
		return "NOT "+fragment.toSqlString();
	}

	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((fragment == null) ? 0 : fragment.hashCode());
		return result;
	}

	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final Not other = (Not) obj;
		if (fragment == null) {
			if (other.fragment != null)
				return false;
		} else if (!fragment.equals(other.fragment))
			return false;
		return true;
	}
}
