/*
  * hgcommons 9
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
  */
package biz.hammurapi.swing;

import java.util.ArrayList;
import java.util.List;

import javax.swing.tree.TreeNode;

import biz.hammurapi.convert.Converter;
import biz.hammurapi.convert.ConvertingService;

/**
 * @author Pavel Vlasov
 *
 * @version $Revision: 1.1 $
 */
public class ArrayVisualizer  {
	
	public Visualizable convert(final Object[] oa, final Converter master) {
		return new Visualizable() {

			public TreeNode toTreeNode(TreeNode parent, String title) {
				return new LazyTreeNode(parent, title+" ["+oa.length+"]") {

					protected List loadChildren() {
						ArrayList ret = new ArrayList();
						for (int i=0; i<oa.length; ++i) {
							Visualizable ev = (Visualizable) ConvertingService.convert(oa[i], Visualizable.class);
							ret.add(ev.toTreeNode(this, "["+i+"]"));
						}
						return ret;
					}
					
				};
			}
			
		};
	}
}
