/*
 * hgcommons 9
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz
 */
package biz.hammurapi.swing;

import java.util.List;

import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;
import javax.swing.tree.TreeNode;

/**
 * @author Pavel Vlasov
 * @revision $Revision: 1.1 $
 */
public class PrimitivesVisualizer {
	
	private static class PrimitiveVisualizable extends LazyTreeNodeTableVisualizable {
		Object o;
		
		public PrimitiveVisualizable(TreeNode parent, String name, Object o) {
			super(parent, name+" ["+o.getClass().getName()+"] "+o, EMPTY_LIST);
			this.o = o;
		}

		public TableModel toTable() {
			DefaultTableModel tm=new DefaultTableModel(1,2);
			tm.setColumnIdentifiers(new String[] {"Type", "Value"});
			tm.setValueAt(o.getClass().getName(), 0, 0);
			tm.setValueAt(o, 0, 1);
			
			return tm;
		}

		protected List loadChildren() {
			return EMPTY_LIST;
		}
		
	}	
	
	public Visualizable convert(final String o) {
		return new Visualizable() {

			public TreeNode toTreeNode(TreeNode parent, String title) {
				return new PrimitiveVisualizable(parent, title, o);
			}
			
		};
	}

	public Visualizable convert(final Number o) {
		return new Visualizable() {

			public TreeNode toTreeNode(TreeNode parent, String title) {
				return new PrimitiveVisualizable(parent, title, o);
			}
			
		};
	}

	public Visualizable convert(final Boolean o) {
		return new Visualizable() {

			public TreeNode toTreeNode(TreeNode parent, String title) {
				return new PrimitiveVisualizable(parent, title, o);
			}
			
		};
	}

	public Visualizable convert(final Character o) {
		return new Visualizable() {

			public TreeNode toTreeNode(TreeNode parent, String title) {
				return new PrimitiveVisualizable(parent, title, o);
			}
			
		};
	}
}
