/*
  * hgcommons 9
 * Hammurapi Group Common Library 
 * Copyright (C) 2003  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://www.hammurapi.biz/hammurapi-biz/ef/xmenu/hammurapi-group/products/products/hgcommons/index.html
 * e-Mail: support@hammurapi.biz 
 */
package biz.hammurapi.util;


/**
 * Helper class to render ${...} sequence in Velocity and
 * encode URL's.
 * @author Pavel
 */
public class Escaper {
	
	/**
	 * Escapes HTML
	 * @param tkn
	 * @return
	 */
	public static String escapeHtml(String txt) {
		if (txt==null) {
			return null;
		}
		
		StringBuffer ret = new StringBuffer();
		char[] chars=txt.toCharArray();
		for (int i=0; i<chars.length; ++i) {
			switch (chars[i]) {
			case '<':
				ret.append("&lt;");
				break;
			case '>':
				ret.append("&gt;");
				break;
			case '&':
				if (i<chars.length-1 && '#'==chars[i+1]) { // Do not double-escape (&#...;)
					ret.append(chars[i]);
				} else {
					ret.append("&amp;");
				}
				break;
			case '\'':
				ret.append("&#039;");
				break;
			case '\\':
				ret.append("&#092;");
				break;
			case '\"':
				ret.append("&quot;");
				break;
			default:
				ret.append("&#"+((int) chars[i])+";");
			}
		}
		return ret.toString();
	}
	
}
